# This script demonstrates the XCodelib library interface for CODE 2.0. This
# file only contains code to enter the components into the XCodelib database 
# from CODE 2.0. 

set ROOT [exec pwd]
set auto_path "$ROOT $auto_path"
set HOME $env(CLIBHOME)

wm title . "Library Component Entry"

frame .menubar
button .menubar.quit -text "Quit" -command exit 
button .menubar.ok -text "Ok" -command "mkOk . \$CompType \$component \
						      \$sourcePath \$fileNames" 
button .menubar.clear -text "Clear" -command "mkClear ." 
button .menubar.help -text "Help" -command "mkHelp" 
pack .menubar.quit .menubar.ok .menubar.clear -side left -pady 5 \
	-padx 5 
pack .menubar.help -side right -pady 5 -padx 10

frame .entry -relief raised -bd 2
frame .entry.type 
label .entry.type.l -text "Component Type :" -width 17 -anchor w
radiobutton .entry.type.c -text "Directory" -variable CompType \
	-value directory -width 27 -anchor w
radiobutton .entry.type.f -text "File" -variable CompType -value file \
	-width 27 -anchor w
pack .entry.type.l .entry.type.c .entry.type.f -side left
pack .entry.type -side top -fill x

frame .entry.component
label .entry.component.l -text "Component Name :" -width 17 -anchor w
entry .entry.component.e -width 60 -relief sunken -bd 2 \
	-textvariable component
pack .entry.component.l .entry.component.e -side left
pack .entry.component -side top -fill x

frame .entry.source
label .entry.source.l -text "Source Path :" -width 17 -anchor w
entry .entry.source.e -width 60 -relief sunken -bd 2 \
	-textvariable sourcePath
.entry.source.e insert 0 [exec pwd] 
pack .entry.source.l .entry.source.e -side left
pack .entry.source -side top -fill x

frame .entry.file
frame .entry.file.one
label .entry.file.one.l1 -text "Enter File Names :" -width 17 -anchor w
pack .entry.file.one.l1 -side top -fill x
label .entry.file.one.l2 -text "                 " -width 17 -anchor w
pack .entry.file.one.l2 -side top -fill x

frame .entry.file.two
entry .entry.file.two.e -width 60 -relief sunken \
	-scroll ".entry.file.two.s set" -bd 2 -textvariable fileNames
pack .entry.file.two.e -side top -fill x
scrollbar .entry.file.two.s -relief sunken -orient horiz \
      -command ".entry.file.two.e view"
pack .entry.file.two.s -side top -fill x
pack .entry.file.one .entry.file.two -side left -fill x
pack .entry.file -side top -fill x

pack .menubar -side top -fill x
pack .entry -side top -fill x

proc mkHelp {} {
	puts stdout "Help"
}

proc mkOk {w CompType component sourcePath fileNames} {
	global HOME

	if {$CompType == "directory"} {
		exec mkdir $HOME/database/$component
		foreach i $fileNames {
			exec cp -r $sourcePath/$i $HOME/database/$component
		}
		set line "$HOME/database/$component/"
		set insert_sql "insert into library \
			   values('$component' , '$line')"
		set idpass "smsk/linu"
   		set logon_handle [oralogon $idpass]
   		set cur [oraopen $logon_handle]
		set returnCode [catch { orasql $cur $insert_sql }]
		if {$returnCode == 1} {
			puts stdout "Error in inserting row into table"
		}
        	oraclose $cur
		oralogoff  $logon_handle
	} elseif {$CompType == "file"} { 
		if {[llength $fileNames] == 1} {
			exec cp -r $sourcePath/$fileNames $HOME/database
			set line "$HOME/database/$fileNames"
			set insert_sql "insert into library \
				   values('$component' , '$line')"
			set idpass "smsk/linu"
   			set logon_handle [oralogon $idpass]
   			set cur [oraopen $logon_handle]
			set returnCode [catch { orasql $cur $insert_sql }]
			if {$returnCode == 1} {
				puts stdout "Error in inserting row into table"
			}
        		oraclose $cur
			oralogoff  $logon_handle
		} else {
			puts stdout "Only one filename should be provided"
		} 
	}
	[set w]entry.component.e delete 0 end
	[set w]entry.source.e delete 0 end
	[set w]entry.file.two.e delete 0 end
	[set w]entry.source.e insert 0 [exec pwd] 
}

proc mkClear {w} {
	[set w]entry.component.e delete 0 end
	[set w]entry.source.e delete 0 end
	[set w]entry.file.two.e delete 0 end
}
