#/projects/tcl/sun4/bin/wish -f
# This script demonstrates the XCodelib library interface for CODE 2.0. This
# file only contains code to generate the main window for the application 
# which invokes individual windows.  

set auto_path "$env(CLIBHOME)/Tcl_Tk $auto_path"
global oramsg

#set the top level window title
wm title . "XCodelib"

#-------------------------------------------------------
# The code below create the main window, consisting of a
# menu bar and a message explaining the basic operation
# of the program.
#-------------------------------------------------------

#set the size of the main window so that it is 50 characters wide and 30 lines 
#high
wm geometry . 500x300
frame .menubar
button .menubar.quit -text "Quit" -command exit 
bind .menubar.quit <Enter> {
	tk_butEnter %W
	.cshelp.l config -text "Exit the session" } 
button .menubar.search -text "Search" -command "mkSearch" 
bind .menubar.search <Enter> {
	tk_butEnter %W
	.cshelp.l config -text "Search the database" } 
button .menubar.library -text "Library" -command "mkLibrary ."
bind .menubar.library <Enter> {
	tk_butEnter %W
	.cshelp.l config -text "display top level library listing" } 
button .menubar.help -text "Help" -state disabled -command "mkTHelp ." 
bind .menubar.help <Enter> {
	tk_butEnter %W
	.cshelp.l config -text "display the Help file" } 
pack .menubar.quit .menubar.search .menubar.library -side left -pady 5 -padx 5 
pack .menubar.help -side right -pady 5 -padx 10

frame .cshelp
label .cshelp.l -text "XCodelib"  -relief groove -width 90
pack .cshelp.l -side bottom  

frame .text -relief raised -bd 2
text .text.t -yscrollcommand ".text.s set" -state disabled -setgrid true \
   -font "-Adobe-Courier-Bold-R-Normal-*-120-*" 
bind .text.t <Enter> {
   	set dir [exec pwd]
	.cshelp.l config -text "XCodelib : $dir" } 
scrollbar .text.s -relief sunken -command ".text.t yview"
pack .text.s -side right -fill y
pack .text.t -expand yes -fill both

frame .canvas -relief raised -bd 2
canvas .canvas.c -height 300 -width 500 -scrollregion {0c 0c 0c 30c} \
          -yscroll ".canvas.s set"
scrollbar .canvas.s -relief sunken -command ".canvas.c yview"
pack .canvas.s -side left -fill y
pack .canvas.c -expand yes -fill both

pack .menubar -side top -fill x
pack .cshelp -side top -fill x
pack .text -side top -fill x

proc TextLoadHelp {w} {
# The utility procedure below loads the Help message into a text widget,
# discarding the previous contents of the widget. Tags for the
# old widget are not affected, however.
# Arguments: none

$w configure -state normal
$w delete 1.0 end
$w insert 0.0 {\
	XCodelib : Component Library Interface for CODE 2.0 

	TOP LEVEL BUTTONS

	Quit - Exits the XCodelib session

	Search - allows the user to find routines by a keyword search

	Library - displays all toplevel Codelib libraries. Clicking on a 
		  library will display its contents. You may then select 
		  components for viewing or downloading, or you may
		  just poke around the heirarchy.

	Help - this screen }
.menubar.help configure -state disabled 
$w configure -state disabled
}

TextLoadHelp .text.t
set SearchType Or
set HOME $env(CLIBHOME)
set DPATH $env(CLIBHOME)/database
set DNAME database
set SELECT [list ]; set ULIST [list ]
set MAXHITS 5
set TYPE Local 			
set SCY 10   			
set SCNo 0   			
set SIMILARLIST [list ]
set LASTQUERY [list ]
set COMPLIST [list ]
