set auto_path "$env(CLIBHOME)/Tcl_Tk $auto_path"

proc displayComponent {w path name} {
   global DPATH DNAME SELECT TYPE HOME
   set DPATH [set path] 
   set DNAME [set name] 

   set c $w.canvas.c 
   set font1 -Adobe-Courier-Bold-R-Normal-*-120-*
   $w.title.entry configure -state normal 
   $w.title.entry delete 0 end
   $w.title.entry insert 0 $name
   $w.title.entry configure -state disabled 
   $c delete all

   switch $TYPE {
	Local	{
   			set first [string last / $path] 
   			set shortPath [string range $path [expr $first+1] end]
   			exec ls -F $path > $HOME/tmp/listing0
   			set x1 10; set y1 100
   			$c create text $x1 $y1 -justify left -anchor w -text \
			$shortPath -font $font1 -tags component
   			set f [open $HOME/tmp/listing0]
   			set lpath [string length $shortPath] 
   			set x [expr $x1+[expr $lpath*9]]; set y 10; set i 0
   			while {[gets $f textString] >= 0} {
        			if [string match */ $textString] {
   					$c create text $x $y -justify left \
					-anchor w -text $textString\
               	 			-font $font1 -tags file.$i 
					set fileName.$i $textString
					$c create line [expr $x1+($lpath*7)+3] $y1\					 [expr $x-3] $y
        			} else {
        				if [regexp {\*$} $textString] {
					set textString [string trimright \
							$textString \*]
					}
   					$c create text $x $y -justify left \
					-anchor w -text $textString\
               	 			-font $font1 -tags file.$i 
					set fileName.$i $textString
					$c create line [expr $x1+($lpath*7)+3] \
					$y1 [expr $x-3] $y
        			}
				incr y 20; incr i
   			}
   			close $f
			if [file exists $HOME/tmp/listing0] {
   				exec rm $HOME/tmp/listing0
			}

			set NoOfFiles $i
			for {set i 0} {$i < $NoOfFiles} {incr i} {
			$c bind file.$i <Enter> "fileEnter $c" 
			$c bind file.$i <Leave> "fileLeave $c" 
			set fileName [set fileName.$i]
			$c bind file.$i <Double-Button-1> "filePress $w $path \
							   $name $fileName"  
			$c bind file.$i <Button-1> "textB1Press $c $path \
						    $fileName"
			$c bind file.$i <Double-Button-2> "textB2DPress $c \
						            $path $fileName"
			}
			$c bind component <Button-1> "componentB1Press $c $path"
			$c bind component <Double-Button-2> "componentB2DPress \
							     $c $path"
		}
	Remote  {
			set first [string last / $name]
			set shortPath [string range $name [expr $first+1] end]
			exec awk -f $HOME/Tcl_Tk/awkrfile $HOME/tmp/tmpls \
                             > $HOME/tmp/listing0
   			set x1 10; set y1 100
   			$c create text $x1 $y1 -justify left -anchor w -text \
			$shortPath -font $font1 -tags rcomponent
   			set f [open $HOME/tmp/listing0]
   			set x 100; set y 10; set i 0
   			set lpath [string length $shortPath] 
			gets $f textString
   			while {[gets $f textString] >= 0} {
        			if [string match */ $textString] {
   					$c create text $x $y -justify left \
					-anchor w -text $textString\
               	 			-font $font1 -tags rfile.$i 
					set rfileName.$i $textString
					$c create line [expr $x1+($lpath*8)] $y1\					 [expr $x-3] $y
        			} else {
   					$c create text $x $y -justify left \
					-anchor w -text $textString\
               	 			-font $font1 -tags rfile.$i 
					set rfileName.$i $textString
					$c create line [expr $x1+($lpath*8)] \
					$y1 [expr $x-3] $y
        			}
				incr y 20; incr i
   			}
   			close $f
			if [file exists $HOME/tmp/listing0] {
   				exec rm $HOME/tmp/listing0
			}

			set NoOfFiles $i
			for {set i 0} {$i < $NoOfFiles} {incr i} {
			$c bind rfile.$i <Enter> "fileEnter $c" 
			$c bind rfile.$i <Leave> "fileLeave $c" 
			set fileName [set rfileName.$i]
			$c bind rfile.$i <Double-Button-1> "rfilePress $w $path \
					                   $name $fileName"  
			$c bind rfile.$i <Button-1> "textB1Press $c $name \
						     $fileName"
			$c bind rfile.$i <Double-Button-2> "textB2DPress $c \
						           $name $fileName"
			}
			$c bind rcomponent <Button-1> "componentB1Press $c \
							$name"
			$c bind rcomponent <Double-Button-2> "componentB2DPress\
							      $c $name"
		}
	}

proc fileEnter {c} {
	$c itemconfigure current -fill Red
}

proc fileLeave {c} {
	$c itemconfigure current -fill Black
}

proc textB2DPress {c path fileName} {
	global SELECT

	set index [lsearch -exact $SELECT $path/$fileName] 
	set SELECT [lreplace $SELECT $index $index]
	set coords [$c bbox current]
	set x1 [lindex $coords 0]
	set y1 [lindex $coords 1]
	set x2 [lindex $coords 2]
	set y2 [lindex $coords 3]
	$c create line $x1 $y2 $x2 $y2 -fill Bisque1 -width 2.0
}

proc componentB2DPress {c path} {
	global SELECT TYPE HOME

	set coords [$c bbox current]
	set x1 [lindex $coords 0]
	set y1 [lindex $coords 1]
	set x2 [lindex $coords 2]
	set y2 [lindex $coords 3]
	$c create line $x1 $y2 $x2 $y2 -fill Bisque1 -width 2.0

	set first [string last / $path]
	set shortPath [string range $path [expr $first+1] end]

	switch $TYPE {
		Local	{
				exec ls -F $path > $HOME/tmp/listing0
		}
		Remote	{
				exec awk -f $HOME/Tcl_Tk/awkrfile \
				$HOME/tmp/tmpls > $HOME/tmp/listing0
		}
	}
	set f [open $HOME/tmp/listing0]
#	set x 100; set y 10

	set lpath [string length $shortPath]
	set x [expr $x1+[expr $lpath*9]]; set y 10

	while {[gets $f textString] >= 0} {
		set index [lsearch -exact $SELECT $path/$textString]
        	set SELECT [lreplace $SELECT $index $index]
		set len [string length $textString]
		$c create line $x [expr $y+6] [expr $x+[expr $len*7]] \
                   [expr $y+6] -fill Bisque1 -width 2.0
		incr y 20
	}
	close $f
	if [file exists $HOME/tmp/listing0] {
		exec rm $HOME/tmp/listing0
	}
}

proc textB1Press {c path fileName} {
	global SELECT

	set SELECT [concat $SELECT $path/$fileName] 
	set coords [$c bbox current]
	set x1 [lindex $coords 0]
	set y1 [lindex $coords 1]
	set x2 [lindex $coords 2]
	set y2 [lindex $coords 3]
	$c create line $x1 $y2 $x2 $y2 -width 2.0 
}

proc componentB1Press {c path} {
	global SELECT TYPE HOME

	set coords [$c bbox current]
	set x1 [lindex $coords 0]
	set y1 [lindex $coords 1]
	set x2 [lindex $coords 2]
	set y2 [lindex $coords 3]
	$c create line $x1 $y2 $x2 $y2 -width 2.0 

	set first [string last / $path]
	set shortPath [string range $path [expr $first+1] end]

	switch $TYPE {
		Local	{
				exec ls -F $path > $HOME/tmp/listing0
		}
		Remote	{
				exec awk -f $HOME/Tcl_Tk/awkrfile \
				$HOME/tmp/tmpls > $HOME/tmp/listing0
		}
	}
	set f [open $HOME/tmp/listing0]
#	set x 100; set y 10

	set lpath [string length $shortPath]
	set x [expr $x1+[expr $lpath*9]]; set y 10

	while {[gets $f textString] >= 0} {
		if [regexp {\*$} $textString] {
			set textString [string trimright $textString \*]
		}
		set SELECT [concat $SELECT $path/$textString]
		set len [string length $textString]
		$c create line $x [expr $y+6] [expr $x+[expr $len*7]] \
                   [expr $y+6] -width 2.0
		incr y 20
	}
	close $f
	if [file exists $HOME/tmp/listing0] {
		exec rm $HOME/tmp/listing0
	}
}


proc filePress {w path name fileName} {
	global DPATH DNAME TYPE

        if [string match */ $fileName] {
	set a /
	set fileName [string trimright $fileName /]
	set path $path$a$fileName
	set DPATH $path
	displayComponent $w $path $name
	} else {
	displayFile $w $path $name $fileName
	} 
}

proc rfilePress {w path name fileName} {
	global DPATH DNAME TYPE HOME

        if [string match */ $fileName] {
		set a /
		set fileName [string trimright $fileName /]
		set name $name$a$fileName
		set DNAME $name
		if [file exists $HOME/tmp/tmpls] {
			exec rm $HOME/tmp/tmpls
		}
		exec $HOME/backend/ftpls $path $name > $HOME/tmp/null
		if [file exists $HOME/tmp/null] {
			exec rm $HOME/tmp/null
		}
		displayComponent $w $path $name
	} else {
		set DNAME $name/$fileName 
		exec $HOME/backend/ftpget $path $name $fileName > $HOME/tmp/null
		if [file exists $HOME/tmp/null] {
			exec rm $HOME/tmp/null
		}
		displayFile $w $path $name $fileName
	} 
}

}
