set auto_path "$env(CLIBHOME)/Tcl_Tk $auto_path"

proc mkDownload {w} {
	global SELECT TYPE DPATH DNAME

	set font1 -Adobe-Courier-Bold-R-Normal-*-120-*
	set c $w.download.canvas.c
	$c delete all
	set x 10; set y 10
	foreach i $SELECT {
		set len [string length  $i]
		$c create text $x $y -justify left -anchor w -text $i\
                   -font $font1 
		$c create line $x [expr $y+7] [expr $x+[expr $len*7]] \
                   [expr $y+7] -width 2.0
		incr y 20
	}

	$w.menubar.download configure -state disabled
	$w.menubar.goup configure -state disabled
	$w.menubar.done configure -state disabled
        $w.download.title.entry delete 0 end
        $w.download.title.entry insert 0 [exec pwd] 

	pack forget $w.canvas
	pack $w.download -side top -fill x
}

proc mkGetFiles {w DownPath} {
	global SELECT TYPE DPATH DNAME HOME
	
	puts stdout "Get Files Now"
	puts stdout "DownLoad Path is $DownPath"
	puts stdout "DNAME is $DNAME"
	switch $TYPE {
		Local	{
			  if [llength $SELECT] {
				set len [llength $SELECT]
				set incr [expr 580/$len]
				set width [expr 20+$incr]
				exec mkdir $DownPath/$DNAME
				foreach i $SELECT {
				exec cp -r $i $DownPath/$DNAME
				$w.download.display.inner config \
				                    -geometry ${width}x30
				set width [expr $width+$incr]
				}
			  } else {
				puts stdout "No files Selected"
			  }
		}
		Remote	{
				set last [string last / $DownPath]
			set CompName [string range $DownPath [expr $last+1] end]
				exec mkdir $DownPath
		                exec mkdir $HOME/database/$CompName
				if [llength $SELECT] {
				        set len [llength $SELECT]
					set incr [expr 580/$len]
					set width [expr 20+$incr]
					foreach i $SELECT {
				           set last [string last / $i]
			      set rfileName [string range $i [expr $last+1] end]
			                   set rdir [string range $i 0 $last]
	     exec $HOME/backend/ftpget $DPATH $rdir $rfileName > $HOME/tmp/null
		                           if [file exists $HOME/tmp/null] {
                                                  exec rm $HOME/tmp/null
                                           }
				 exec cp -r $rfileName $HOME/database/$CompName
					   exec mv $rfileName $DownPath
				           $w.download.display.inner config \
				                    -geometry ${width}x30
				           set width [expr $width+$incr]
					}
				        set line "$HOME/database/$CompName/"
					set insert_sql "insert into library \
						 values('$CompName' , '$line')"
					set idpass "smsk/linu"
        				set logon_handle [oralogon $idpass]
        				set cur [oraopen $logon_handle]
        		      set returnCode [catch { orasql $cur $insert_sql }]
        				if {$returnCode == 1} {
                		puts stdout "Error in inserting row into table"
        				}
        				oraclose $cur
        				oralogoff  $logon_handle
				} else {
					puts stdout "No files Selected"
				}
		}
	}
	set SELECT [list ]
	$w.download.canvas.c delete all
}

proc UnselectFiles {w} {
	global SELECT ULIST

	set c $w.download.canvas.c
	set x 10; set y 10
	foreach i $SELECT {
		set len [string length  $i]
		$c create line $x [expr $y+7] [expr $x+[expr $len*7]] \
                   [expr $y+7] -width 2.0 -fill Bisque1
		incr y 20
	}
	set ULIST $SELECT
	set SELECT [list ]
}

proc SelectFiles {w} {
	global SELECT ULIST

	set SELECT $ULIST
	set c $w.download.canvas.c
	set x 10; set y 10
	foreach i $SELECT {
		set len [string length  $i]
		$c create line $x [expr $y+7] [expr $x+[expr $len*7]] \
                   [expr $y+7] -width 2.0
		incr y 20
	}
}

proc mkDownReturn {w} {
	global DPATH DNAME TYPE HOME

	$w.menubar.download configure -state normal 
	$w.menubar.goup configure -state normal
	$w.menubar.done configure -state normal 
	pack forget $w.download
	pack $w.canvas -side top -fill x
	set path $DPATH
	set name $DNAME
	switch $TYPE {
		Local	{
				displayComponent $w $path $name
		}
		Remote	{
				if [file exists $HOME/tmp/tmpls] {
					exec rm $HOME/tmp/tmpls
				}
				exec $HOME/backend/ftpls $path $name \
					> $HOME/tmp/null
				if [file exists $HOME/tmp/null] {
					exec rm $HOME/tmp/null
				}
				displayComponent $w $path $name
		}
	}
}
