set auto_path "$env(CLIBHOME)/Tcl_Tk $auto_path"

proc mkFDownload {w fpath fname} {
	global SELECT TYPE

	set font1 -Adobe-Courier-Bold-R-Normal-*-120-*
	set c $w.download.canvas.c
	$c delete all
	set x 10; set y 10
	foreach i $SELECT {
		set len [string length  $i]
		$c create text $x $y -justify left -anchor w -text $i\
                   -font $font1 
		$c create line $x [expr $y+7] [expr $x+[expr $len*7]] \
                   [expr $y+7] -width 2.0
		incr y 20
	}

	$w.menubar.download configure -state disabled
	$w.menubar.done configure -state disabled
        $w.download.title.entry delete 0 end
        $w.download.title.entry insert 0 [exec pwd] 

	pack forget $w.text
	pack $w.download -side top -fill x
}

proc mkFGetFiles {w DownPath} {
	global SELECT TYPE DPATH HOME DNAME
	
	puts stdout "Get Files Now"
	puts stdout "DownLoad Path is $DownPath"
	switch $TYPE {
		Local	{
				if {[llength $SELECT] == 1} {
					puts stdout $SELECT
					set len [llength $SELECT]
                                        set incr [expr 580/$len]
                                        set width [expr 20+$incr]
					exec cp -r $SELECT $DownPath
				        $w.download.display.inner config \
                                                    -geometry ${width}x30
                                        set width [expr $width+$incr]	
				} else {
					puts stdout "No files Selected"
				}
		}
		Remote	{
				puts stdout "Remote host name $DPATH"
				if {[llength $SELECT] == 1} {
					puts stdout $SELECT
					set len [llength $SELECT]
                                        set incr [expr 580/$len]
                                        set width [expr 20+$incr]
					set last [string last / $SELECT]
			 set rfileName [string range $SELECT [expr $last+1] end]
			                set rdir [string range $SELECT 0 $last]
	      exec $HOME/backend/ftpget $DPATH $rdir $rfileName > $HOME/tmp/null
				        if [file exists $HOME/tmp/null] {
                                                  exec rm $HOME/tmp/null
                                        }
				        exec cp -r $rfileName $HOME/database
					exec mv $rfileName $DownPath
				        $w.download.display.inner config \
                                                    -geometry ${width}x30
                                        set width [expr $width+$incr]
					set line "$HOME/database/$rfileName"
					set insert_sql "insert into library \
						values('$rfileName' , '$line')"
					set idpass "smsk/linu"
                                        set logon_handle [oralogon $idpass]
                                        set cur [oraopen $logon_handle]
                              set returnCode [catch { orasql $cur $insert_sql }]
                                        if {$returnCode == 1} {
                                puts stdout "Error in inserting row into table"
                                        }
                                        oraclose $cur
                                        oralogoff  $logon_handle
				} else {
					puts stdout "No files Selected"
				}
		}
	}
	set SELECT [list ]
	$w.download.canvas.c delete all
}

proc FUnselectFiles {w} {
	global SELECT ULIST

	set c $w.download.canvas.c
	set x 10; set y 10
	foreach i $SELECT {
		set len [string length  $i]
		$c create line $x [expr $y+7] [expr $x+[expr $len*7]] \
                   [expr $y+7] -width 2.0 -fill Bisque1
		incr y 20
	}
	set ULIST $SELECT
	set SELECT [list ]
}

proc FSelectFiles {w} {
	global SELECT ULIST

	set SELECT $ULIST
	set c $w.download.canvas.c
	set x 10; set y 10
	foreach i $SELECT {
		set len [string length  $i]
		$c create line $x [expr $y+7] [expr $x+[expr $len*7]] \
                   [expr $y+7] -width 2.0
		incr y 20
	}
}

proc mkFDownReturn {w} {

	$w.menubar.download configure -state normal 
	$w.menubar.done configure -state normal 
	pack forget $w.download
	pack $w.text -side top -fill x
}
