set auto_path "$env(CLIBHOME)/Tcl_Tk $auto_path"

proc mkLibrary {w} {
	global DPATH DNAME TYPE HOME
	set DPATH $HOME/database
	set DNAME database
	set TYPE Local
	set c [set w]canvas.c
        $c delete all
	set font1 -Adobe-Courier-Bold-R-Normal-*-120-*
        pack forget [set w]text
    	pack [set w]canvas -side top -fill x
	[set w]menubar.help configure -state normal
	[set w]menubar.library configure -state disabled 
	set path $DPATH 

	exec ls -F $path > $HOME/tmp/listing0
	set f [open $HOME/tmp/listing0]
	set x 10; set y 10; set i 0; set j 0
	set col 0
	while {[gets $f textString] >= 0} {
		if [string match */ $textString] {
			$c create bitmap $x $y \
                          -bitmap @$HOME/Tcl_Tk/Bitmaps/component.bit -tags component.$i 
			set tmp [string trimright $textString /]
			set path.$i $path/$tmp
			set name.$i $tmp
			$c create text [expr $x+25] $y -justify left -anchor w\
			-text [string trim $textString /] -font $font1 \
                        -tags component.$i 
			incr i
		} else {
			$c create bitmap $x $y \
			  -bitmap @$HOME/Tcl_Tk/Bitmaps/file.bit -tags fcomponent.$j 
			set fpath.$j $path
			set fname.$j $textString
			$c create text [expr $x+25] $y -justify left -anchor w\
			-text [string trim $textString /] -font $font1 \
                        -tags fcomponent.$j 
			incr j
		}
		incr col
		if {$col < 2} { 
			incr x 250
		} elseif {$col == 2} {
			set x 10; incr y 20; set col 0
		}  
	}
	close $f
	if [file exists $HOME/tmp/listing0] {
		exec rm $HOME/tmp/listing0
	}
 
set TYPE Local
set NoOfComponents $i
for {set i 0} {$i < $NoOfComponents} {incr i} {
$c bind component.$i <Enter> "itemEnter $c $i" 
$c bind component.$i <Leave> "itemLeave $c $i" 
set path [set path.$i] 
set name [set name.$i] 
$c bind component.$i <Double-1> "mkComponent $path $name" 
}

set TYPE Local
set NoOfFComponents $j
for {set j 0} {$j < $NoOfFComponents} {incr j} {
$c bind fcomponent.$j <Enter> "fitemEnter $c $j" 
$c bind fcomponent.$j <Leave> "fitemLeave $c $j" 
set fpath [set fpath.$j] 
set fname [set fname.$j] 
$c bind fcomponent.$j <Double-1> "mkFComponent $fpath $fname" 
}

proc itemEnter {c index} {
	set l [$c find withtag component.$index]
        foreach i $l {
                set type [$c type $i]
                if {$type == "bitmap"} {
                $c itemconfigure $i -foreground Red
                }
                if {$type == "text"} {
                $c itemconfigure $i -fill Red
                }
        }
}

proc fitemEnter {c index} {
	set l [$c find withtag fcomponent.$index]
        foreach i $l {
                set type [$c type $i]
                if {$type == "bitmap"} {
                $c itemconfigure $i -foreground Red
                }
                if {$type == "text"} {
                $c itemconfigure $i -fill Red
                }
        }
}

proc itemLeave {c index} {
	set l [$c find withtag component.$index]
        foreach i $l {
                set type [$c type $i]
                if {$type == "bitmap"} {
                $c itemconfigure $i -foreground Black
                }
                if {$type == "text"} {
                $c itemconfigure $i -fill Black
                }
        }

}

proc fitemLeave {c index} {
	set l [$c find withtag fcomponent.$index]
        foreach i $l {
                set type [$c type $i]
                if {$type == "bitmap"} {
                $c itemconfigure $i -foreground Black
                }
                if {$type == "text"} {
                $c itemconfigure $i -fill Black
                }
        }

}

}
