/* Block Triangular solver - Sequential C.  Uses CODE array rep  */

/*  Build with cc -O -o seq seq.c -lseq */

#include <stdio.h>
#include <usclkc.h>

static usclk_t StartTime;
static usclk_t DefTime;
static usclk_t EndTime;

char *malloc();
void free();

typedef double real;
typedef double *Vector;
typedef Vector *Matrix;

  /* prompt for user input */

void readsize(n, blk, printp)
  int *n;
  int *blk;
  int *printp;
{
  int numblks;

  printf("Enter the size of the block system: ");
  scanf("%d", &numblks);

  printf("Enter the size of a block (integer): ");
  scanf("%d", blk);

  *n = numblks*(*blk);
   
  printf("Print all (0 or 1): ");
  scanf("%d", printp);
}

  /* Allocate space for b */

Vector MakeB(n)
   int n;
{
   return (Vector) malloc(n*sizeof(real));
}

  /* Allocate space for A */

Matrix MakeA(n)
   int n;
{
   Matrix t;
   int i;

   t = (Matrix) malloc(n*sizeof(Vector));

   for (i = 0; i < n; i++)
      t[i] = (Vector) malloc((i+1)*sizeof(real));

   return t;
}

  /* Allocare and obtain values for a and b */

void readsys(n, a, b)
   int n;
   Matrix a;
   Vector b;
{
   int i, j;
   Vector tmp;

   for (i = 0; i < n; i++) {
      b[i] = i + 1.0;
      tmp = a[i];
      for (j = 0; j <= i; j++)
        tmp[j] = 1.0;
   }
}


   /* print b */

void printans(n, b, printp)
   int n;
   Vector b;
   int printp;
{
   int start, stop;
   int i;

   if (printp == 0) {
      start = n/2;
      stop = start;
   } else {
      start = 0;
      stop = n - 1;
   }

   for (i = start; i <= stop; i++)
     printf("x[%d] = %f\n", i, b[i]);
}



void solve(n, a, x)
   int n;
   Matrix a;
   Vector x;
{
   double sum;
   Vector tmp;
   int i;
   int j;

   for (i = 0; i < n; i++) {
      sum = x[i];
      tmp = a[i];
      for (j = 0; j < i; j++)
	sum = sum - tmp[j]*x[j];
      x[i] = sum / tmp[i];
   }
}

main ()
{  
   Vector x;
   Matrix a;
   int n;
   int dummy;
   int printp;

   usclk_init();
   StartTime = getusclk();

   readsize(&n, &dummy, &printp);
   x = MakeB(n);
   a = MakeA(n);
   readsys(n, a, x);
   DefTime = getusclk();
   solve(n, a, x);
   printans(n, x, printp);
   EndTime = getusclk();
   printf("Total = %u, Solve = %u\n", EndTime - StartTime, EndTime - DefTime);
}
